"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var background_fetch_1 = require("./background-fetch");
var Fetch = com.transistorsoft.tsbackgroundfetch.BackgroundFetch;
var CompletionHandler = com.transistorsoft.tsbackgroundfetch.FetchJobService.CompletionHandler;
var HeadlessJobService = /** @class */ (function (_super) {
    __extends(HeadlessJobService, _super);
    function HeadlessJobService() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HeadlessJobService.prototype.onStartJob = function (params) {
        var _this = this;
        Fetch.getInstance(this.getApplicationContext()).registerCompletionHandler(new CompletionHandler({
            finish: function () {
                console.log('[HeadlessJobService] finish');
                _this.jobFinished(params, false);
            }
        }));
        if (!background_fetch_1.BackgroundFetch.invokeHeadlessTask()) {
            this.jobFinished(params, false);
        }
        return true;
    };
    HeadlessJobService.prototype.onStopJob = function (params) {
        this.jobFinished(params, false);
        return true;
    };
    HeadlessJobService = __decorate([
        JavaProxy("com.transistorsoft.backgroundfetch.HeadlessJobService")
    ], HeadlessJobService);
    return HeadlessJobService;
}(android.app.job.JobService));
