"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var common_1 = require("./common");
var TAG = "NSBackgroundFetch";
var emptyFn = function () { };
var BackgroundFetch = /** @class */ (function (_super) {
    __extends(BackgroundFetch, _super);
    function BackgroundFetch() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BackgroundFetch.performFetchWithCompletionHandler = function (completionHandler, state) {
        TSBackgroundFetch.sharedInstance().performFetchWithCompletionHandlerApplicationState(completionHandler, state);
    };
    BackgroundFetch.configure = function (config, callback, failure) {
        var _this = this;
        var fetchManager = TSBackgroundFetch.sharedInstance();
        fetchManager.configureCallback(config, function (status) {
            if (status != 2 /* Available */) {
                console.warn(TAG, "failed to start TSBackgroundFetch");
                failure(status);
                return;
            }
            _this.configured = true;
            fetchManager.addListenerCallback(TAG, callback);
            fetchManager.start();
        });
    };
    BackgroundFetch.start = function (success, failure) {
        success = success || emptyFn;
        failure = failure || emptyFn;
        TSBackgroundFetch.sharedInstance().start(function (status) {
            if (status == 2 /* Available */) {
                success();
            }
            else {
                console.warn(TAG, "failed to start TSBackgroundFetch");
                failure(status);
            }
        });
    };
    BackgroundFetch.stop = function (success, failure) {
        success = success || emptyFn;
        failure = failure || emptyFn;
        TSBackgroundFetch.sharedInstance().stop();
        success();
    };
    BackgroundFetch.status = function (success) {
        TSBackgroundFetch.sharedInstance().status(function (status) {
            success(status);
        });
    };
    BackgroundFetch.finish = function (result) {
        result = result || this.FETCH_RESULT_NO_DATA;
        TSBackgroundFetch.sharedInstance().finishResult(TAG, result);
    };
    // Note: Android-only
    BackgroundFetch.registerHeadlessTask = function (callback) { };
    // Note: Android-only
    BackgroundFetch.invokeHeadlessTask = function () { };
    return BackgroundFetch;
}(common_1.AbstractBackgroundFetch));
exports.BackgroundFetch = BackgroundFetch;
